"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = __importDefault(require("@curveball/controller"));
const dist_1 = require("@curveball/http-errors/dist");
const userService = __importStar(require("../../user/service"));
const hal = __importStar(require("../formats/hal"));
const groupService = __importStar(require("../service"));
class GroupMemberItemController extends controller_1.default {
    async get(ctx) {
        const user = await userService.findById(parseInt(ctx.state.params.id, 10));
        /**
         * Checks if user type is a group
         */
        if (!groupService.isGroup(user)) {
            throw new dist_1.BadRequest('This endpoint only exists for groups');
        }
        const members = await groupService.findAllGroupMembers(user);
        ctx.response.body = hal.collection(user, members);
    }
    async put(ctx) {
        const group = await userService.findById(parseInt(ctx.state.params.id, 10));
        if (!groupService.isGroup(group)) {
            throw new dist_1.BadRequest('This endpoint only exists for groups');
        }
        ctx.request.body = await groupService.findAllGroupMembers(group);
    }
}
exports.default = new GroupMemberItemController();
//# sourceMappingURL=item.js.map