"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = __importDefault(require("@curveball/controller"));
const http_errors_1 = require("@curveball/http-errors");
const userService = __importStar(require("../../user/service"));
// import * as hal from '../formats/hal';
const groupService = __importStar(require("../service"));
const html_1 = require("../formats/html");
class GroupMemberCollectionController extends controller_1.default {
    async get(ctx) {
        const group = await userService.findById(parseInt(ctx.state.params.id, 10));
        if (!groupService.isGroup(group)) {
            throw new http_errors_1.BadRequest('User must be a group to gain access!!');
        }
        ctx.response.type = 'text/html';
        ctx.response.body = html_1.addUserToGroupMemberForm(group, ctx.query.msg, ctx.query.error);
    }
    async post(ctx) {
        const group = await userService.findById(parseInt(ctx.state.params.id, 10));
        if (!groupService.isGroup(group)) {
            throw new http_errors_1.BadRequest('User must be a group to gain access!!');
        }
        const userId = ctx.request.body.userId;
        await groupService.save(userId, group);
        ctx.response.status = 303;
        ctx.response.headers.set('Location', '/user/' + group.id + '/member');
    }
}
exports.default = new GroupMemberCollectionController();
//# sourceMappingURL=new.js.map