"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = require("@curveball/controller");
const hal_1 = require("./formats/hal");
const privilegeService = require("../privilege/service");
class HomeController extends controller_1.default {
    async get(ctx) {
        // eslint-disable-next-line @typescript-eslint/no-var-requires
        const version = require('../../package.json').version;
        const user = ctx.state.user;
        const isAdmin = await privilegeService.hasPrivilege(user, 'admin', '*');
        ctx.response.body = hal_1.default(version, user, isAdmin);
    }
}
exports.default = new HomeController();
//# sourceMappingURL=controller.js.map