"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loginForm = void 0;
const templates_1 = require("../../templates");
function loginForm(msg, error, hiddenFields, registrationEnabled, totp) {
    let totpRequired;
    let totpEnabled;
    switch (totp) {
        case 'required':
            totpRequired = true;
            totpEnabled = true;
            break;
        case 'optional':
            totpRequired = false;
            totpEnabled = true;
            break;
        case 'disabled':
            totpRequired = false;
            totpEnabled = false;
            break;
    }
    return templates_1.render('login', {
        title: 'Login',
        msg: msg,
        error: error,
        hiddenFields: hiddenFields,
        registrationEnabled,
        action: '/authorize',
        totpRequired: totpRequired,
        totpEnabled: totpEnabled
    });
}
exports.loginForm = loginForm;
//# sourceMappingURL=html.js.map