"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOAuth2ClientFromBody = exports.getOAuth2ClientFromBasicAuth = void 0;
const http_errors_1 = require("@curveball/http-errors");
const errors_1 = require("./errors");
const parse_basic_auth_1 = __importDefault(require("./parse-basic-auth"));
const oauth2Service = __importStar(require("./service"));
async function getOAuth2ClientFromBasicAuth(ctx) {
    let oauth2Client;
    const basicAuth = parse_basic_auth_1.default(ctx);
    if (!basicAuth) {
        throw new http_errors_1.Unauthorized('Invalid Basic Auth header');
    }
    try {
        oauth2Client = await oauth2Service.getClientByClientId(basicAuth[0]);
    }
    catch (e) {
        if (e instanceof http_errors_1.NotFound) {
            throw new http_errors_1.Unauthorized('Client id or secret incorrect', 'Basic');
        }
        else {
            // Rethrow
            throw e;
        }
    }
    if (!await oauth2Service.validateSecret(oauth2Client, basicAuth[1])) {
        throw new http_errors_1.Unauthorized('Client id or secret incorrect', 'Basic');
    }
    return oauth2Client;
}
exports.getOAuth2ClientFromBasicAuth = getOAuth2ClientFromBasicAuth;
async function getOAuth2ClientFromBody(ctx) {
    if (!ctx.request.body.client_id) {
        throw new errors_1.InvalidRequest('The "client_id" property is required');
    }
    try {
        return await oauth2Service.getClientByClientId(ctx.request.body.client_id);
    }
    catch (e) {
        if (e instanceof http_errors_1.NotFound) {
            throw new http_errors_1.Unauthorized('Client id unknown', 'Basic');
        }
        else {
            // Rethrow
            throw e;
        }
    }
}
exports.getOAuth2ClientFromBody = getOAuth2ClientFromBody;
//# sourceMappingURL=utilities.js.map