"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = __importDefault(require("@curveball/controller"));
const http_errors_1 = require("@curveball/http-errors");
const server_settings_1 = require("../server-settings");
const userService = __importStar(require("../user/service"));
const html_1 = require("./formats/html");
class RegistrationController extends controller_1.default {
    async get(ctx) {
        ctx.response.type = 'text/html';
        ctx.response.body = html_1.registrationForm(ctx.query.msg, ctx.query.error);
    }
    async post(ctx) {
        const userPassword = ctx.request.body.password;
        const confirmPassword = ctx.request.body.confirmPassword;
        if (userPassword !== confirmPassword) {
            ctx.status = 303;
            ctx.response.headers.set('Location', '/register?error=Password+mismatch.+Please+try+again');
            return;
        }
        try {
            await userService.findByIdentity('mailto:' + ctx.request.body.emailAddress);
            ctx.status = 303;
            ctx.response.headers.set('Location', '/register?error=User+already+exists');
            return;
        }
        catch (err) {
            if (!(err instanceof http_errors_1.NotFound)) {
                throw err;
            }
        }
        const user = await userService.save({
            identity: 'mailto:' + ctx.request.body.emailAddress,
            nickname: ctx.request.body.nickname,
            created: new Date(),
            type: 'user',
            active: false
        });
        await userService.createPassword(user, userPassword);
        ctx.status = 303;
        ctx.response.headers.set('Location', '/login?msg=Registration+successful.+Please log in');
    }
    async dispatch(ctx) {
        if (!server_settings_1.getSetting('registration.enabled')) {
            throw new http_errors_1.Forbidden('This feature is disabled');
        }
        return super.dispatch(ctx);
    }
}
exports.default = new RegistrationController();
//# sourceMappingURL=controller.js.map