"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = __importDefault(require("@curveball/controller"));
const http_errors_1 = require("@curveball/http-errors");
const service_1 = __importDefault(require("../log/service"));
const types_1 = require("../log/types");
const userService = __importStar(require("../user/service"));
const html_1 = require("./formats/html");
const service_2 = require("./service");
class ResetPasswordController extends controller_1.default {
    async get(ctx) {
        ctx.response.type = 'text/html';
        ctx.response.body = html_1.resetPasswordForm(ctx.query.msg);
    }
    async post(ctx) {
        let user;
        try {
            user = await userService.findByIdentity('mailto:' + ctx.request.body.emailAddress);
        }
        catch (err) {
            if (err instanceof http_errors_1.NotFound) {
                ctx.status = 303;
                ctx.response.headers.set('location', '/reset-password?msg=We+can\'t+seem+to+find+your+record.+Please+try+gain');
                return;
            }
            else {
                throw err;
            }
        }
        await service_2.sendResetPasswordEmail(user);
        await service_1.default(types_1.EventType.resetPasswordRequest, ctx.ip(), user.id);
        ctx.status = 303;
        ctx.response.headers.set('location', '/reset-password?msg=We\'ve+sent+you+a+link+to+your+email+for+changing+password');
    }
}
exports.default = new ResetPasswordController();
//# sourceMappingURL=controller.js.map