"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = __importDefault(require("@curveball/controller"));
const http_errors_1 = require("@curveball/http-errors");
const service_1 = __importDefault(require("../../log/service"));
const types_1 = require("../../log/types");
const UserService = __importStar(require("../../user/service"));
const redirect_1 = require("../formats/redirect");
class ResetPasswordController extends controller_1.default {
    async get(ctx) {
        if (!ctx.state.session.resetPasswordUser) {
            throw new http_errors_1.Forbidden('You can only use this endpoint after you went through the \'forgot password\' flow');
        }
        ctx.response.type = 'text/html';
        ctx.response.body = redirect_1.resetPasswordForm(ctx.query.msg);
    }
    async post(ctx) {
        if (!ctx.state.session.resetPasswordUser) {
            throw new http_errors_1.Forbidden('You can only use this endpoint after you went through the \'forgot password\' flow');
        }
        const user = ctx.state.session.resetPasswordUser;
        const resetNewPassword = ctx.request.body.newPassword;
        const confirmNewPassword = ctx.request.body.confirmNewPassword;
        if (resetNewPassword !== confirmNewPassword) {
            ctx.status = 303;
            ctx.response.headers.set('Location', '/reset-password/change-password?msg=New+password+mismatch.+Please+try+again');
            return;
        }
        await UserService.updatePassword(user, resetNewPassword);
        delete ctx.state.session.resetPasswordUser;
        service_1.default(types_1.EventType.resetPasswordSuccess, ctx.ip(), user.id);
        ctx.status = 303;
        ctx.response.headers.set('Location', '/login?msg=Your+new+password+has+been+saved');
    }
}
exports.default = new ResetPasswordController();
//# sourceMappingURL=redirect.js.map