"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = __importDefault(require("@curveball/controller"));
const service_1 = __importDefault(require("../../log/service"));
const types_1 = require("../../log/types");
const UserService = __importStar(require("../../user/service"));
const html_1 = require("../formats/html");
class resetpasswordRedirectController extends controller_1.default {
    async get(ctx) {
        ctx.response.type = 'text/html';
        ctx.response.body = html_1.resetPasswordForm(ctx.query.msg);
    }
    async post(ctx) {
        const user = ctx.state.session.user;
        const currentPassword = ctx.request.body.currentPassword;
        const userNewPassword = ctx.request.body.newPassword;
        const confirmNewPassword = ctx.request.body.confirmNewPassword;
        if (!await UserService.validatePassword(user, currentPassword)) {
            ctx.status = 303;
            ctx.response.headers.set('Location', '/changepassword?msg=Current+password+isn\'t+correct.+Please+try+again');
            return;
        }
        if (userNewPassword !== confirmNewPassword) {
            ctx.status = 303;
            ctx.response.headers.set('Location', '/changepassword?msg=New+password+mismatch.+Please+try+again');
            return;
        }
        await UserService.updatePassword(user, userNewPassword);
        ctx.state.session = {
            user: user,
        };
        service_1.default(types_1.EventType.changePasswordSuccess, ctx);
        ctx.status = 303;
        ctx.response.headers.set('Location', '/');
    }
}
exports.default = new resetpasswordRedirectController();
//# sourceMappingURL=reset-password-redirect.js.map